################ Copyright 2005-2016 Team GoldenEye: Source #################
#
# This file is part of GoldenEye: Source's Python Library.
#
# GoldenEye: Source's Python Library is free software: you can redistribute 
# it and/or modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation, either version 3 of the License, 
# or(at your option) any later version.
#
# GoldenEye: Source's Python Library is distributed in the hope that it will 
# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
# Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GoldenEye: Source's Python Library.
# If not, see <http://www.gnu.org/licenses/>.
#############################################################################
from GamePlay import GEScenario
from .Utils import GetPlayers
import GEPlayer, GEUtil, GEMPGameRules as GERules, GEGlobal as Glb, GEPlayer, GEWeapon

USING_API = Glb.API_VERSION_1_2_0

class CasualDeathMatch( GEScenario ):
    def GetPrintName( self ):
        return "Casual Deathmatch"

    def GetScenarioHelp( self, help_obj ):
        help_obj.SetDescription( "It's deathmatch, but you spawn with half armor and the level 4 weapon." )

    def GetGameDescription( self ):
        if GERules.IsTeamplay():
            return "Team Casual Deathmatch"
        else:
            return "Casual Deathmatch"

    def OnPlayerSpawn( self, player ):
        player.SetArmor( int( Glb.GE_MAX_ARMOR / 2 ) )

        noSwitchList = [ "weapon_none", "weapon_grenade_launcher", "weapon_knife", "weapon_knife_throwing", "weapon_remotemine", "weapon_timedmine", "weapon_proximitymine", "weapon_grenade" ]

        level4Weapon = GEWeapon.WeaponClassname(GERules.GetWeaponInSlot(3))
        # Just give a fair helping of ammo.  This will max out most weapons but that's okay, it's Casual Deathmatch.
        player.GiveNamedWeapon( level4Weapon, 100 )

        if level4Weapon not in noSwitchList: # Don't make the default weapon something difficult to use, or a utility weapon as players might not realize they have other choices.
            player.WeaponSwitch( level4Weapon )
