################ Copyright 2005-2016 Team GoldenEye: Source #################
#
# This file is part of GoldenEye: Source's Python Library.
#
# GoldenEye: Source's Python Library is free software: you can redistribute 
# it and/or modify it under the terms of the GNU General Public License as 
# published by the Free Software Foundation, either version 3 of the License, 
# or(at your option) any later version.
#
# GoldenEye: Source's Python Library is distributed in the hope that it will 
# be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General 
# Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with GoldenEye: Source's Python Library.
# If not, see <http://www.gnu.org/licenses/>.
#############################################################################
from GamePlay import GEScenario
from .Utils import GetPlayers
import GEPlayer, GEUtil, GEMPGameRules as GERules, GEGlobal as Glb, GEPlayer, GEWeapon

USING_API = Glb.API_VERSION_1_2_0

class CasualDeathMatchX( GEScenario ):
    def GetPrintName( self ):
        return "Casual Deathmatch X"

    def GetScenarioHelp( self, help_obj ):
        help_obj.SetDescription( "Just deathmatch, but you spawn with almost full armor and the level 4, 5, 6, and 7 weapons." )

    def GetGameDescription( self ):
        if GERules.IsTeamplay():
            return "Team Casual Deathmatch X"
        else:
            return "Casual Deathmatch X"

    def OnPlayerSpawn( self, player ):
        player.SetArmor( int( Glb.GE_MAX_ARMOR * 7/8 ) )

        noSwitchList = [ "weapon_none", "weapon_grenade_launcher", "weapon_knife", "weapon_knife_throwing", "weapon_remotemine", "weapon_timedmine", "weapon_proximitymine", "weapon_grenade" ]

        for j in range(3, 7):
            levelWeapon = GEWeapon.WeaponClassname(GERules.GetWeaponInSlot(j))
            # Just give as much ammo as possible.  This will max out all weapons but that's okay, it's a casual mode.
            player.GiveNamedWeapon( levelWeapon, 800 )
            
            if levelWeapon not in noSwitchList: # Don't make the default weapon something difficult to use, or a utility weapon as players might not realize they have other choices.
                player.WeaponSwitch( levelWeapon )
